
var coop = require("coop");
var dispatch = require("dispatch");

var exports = module.exports = {};

var RESOURCES = exports.RESOURCES = [];

var Resource = exports.Resource = new coop.Class([coop.Options], {
	initialize: function(options) {
		this.super(options);
		
		this.name = this.options.name;

		RESOURCES.push(this);
	},
	
	list: function (callback) {
		callback(null, []);
	},

	createAPI: function () {
		var r = this;
		return function (req,res) {
			r.list(function (err, data) {
				res.json({
					objects: data
				});	
			})
		}
	}
});

new Resource({ name: "test" });

exports.createAPI = function () {
	var api = {};
	RESOURCES.forEach(function (r) {
		api[r.name] = r.createAPI();
	});
	console.log("API", api);
	return api;
}